
// ==UserScript==
// @name           Skip Redirect
// @description    Skip diverse redirects.
// @include        *
// ==/UserScript==

/*
 *	Home:      http://userscripts.org/scripts/show/12295
 *	ChangeLog: http://skip-redirect-userscript.blogspot.com
 */

/*
 *	URI - GENERIC
 */
OFFICIAL_SCHEME = "(aaas|aaa|acap|afs|cap|cid|crid|data|dav|dict|dns|dtn|fax|file|ftp|gopher|go|h323|https|http|iax2|icap|imap|im|info|ipp|iris\\.beep|iris\\.lwz|iris\\.xpcs|iris\\.xpc|iris|ldap|mailserver|mailto|mid|modem|msrps|msrp|mtqp|mupdate|news|nfs|nntp|opaquelocktoken|pack|pop|pres|prospero|rtsp|service|shttp|sips|sip|snmp|soap\\.beeps|soap\\.beep|tag|telnet|tel|tftp|thismessage|tip|tn3270|tv|urn|vemmi|wais|xmlrpc\\.beeps|xmlrpc\\.beep|xmpp|z39\\.50r|z39\\.50s)";
UNOFFICIAL_SCHEME = "(about|addbook|afp|aim|applescript|bcp|bk|btspp|callto|castanet|cdv|chrome|chttp|cvs|daytime|device|doi|ed2k|eid|enp|feed|finger|fish|freenet|gg|gizmoproject|gsiftp|gsm-sms|h324|hdl|hnews|httpsy|iioploc|ilu|IOR|ircs|irc|itms|jar|javascript|jdbc|klik|kn|lastfm|ldaps|lifn|livescript|lrq|magnet|mailbox|man|md5|mms|mocha|moz-abmdbdirectory|msnim|myim|notes|nsfw|oai|pcast|phone|php|pop3|printer|psyc|pyimp|rdar|res|rsync|rvp|rwhois|rx|sdp|secondlife|sftp|skype|smb|sms|snews|soap\\.udp|soldat|ssh|steam|SubEthaEdit|svn\\+ssh|svn|t120|tann|tcp|telephone|txmt|uddi|unreal|ut2004|uuid|videotex|view-source|wcap|webcal|whodp|whois\\+\\+|whois|wpn|wtai|xeerkat|xfire|ymsgr)";
const SCHEME = "(" + OFFICIAL_SCHEME + "|" + UNOFFICIAL_SCHEME + "):";
const IP_LITERAL = "(\\[((([a-f\\d]{1,4}:){6}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(::([a-f\\d]{1,4}:){5}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(([a-f\\d]{1,4})?::([a-f\\d]{1,4}:){4}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|((([a-f\\d]{1,4}:)?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){3}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,2})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:){2}([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,3})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,4})?[a-f\\d]{1,4})?::([a-f\\d]{1,4}:[a-f\\d]{1,4})|((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])))|(((([a-f\\d]{1,4}:){1,5})?[a-f\\d]{1,4})?::[a-f\\d]{1,4})|(((([a-f\\d]{1,4}:){1,6})?[a-f\\d]{1,4})?::))\\])";
const IPV4ADDRESS = "((([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}([1-9]?\\d|1\\d{2}|2[0-4]\\d|25[0-5]))";
const IP = "(" + IPV4ADDRESS + "|" + IP_LITERAL + ")";
const HIER_PART = "(((\\/\\/)?((([\\w-.~!$&'()*+,;=:]|%[a-f\\d]{2})*@)?(" + IP + "|([\\w-.~!$&'()*+,;=]|%[a-f\\d]{2})*)(:\\d+)?))([\\w-.~!$&'()*+,;=:@/]|%[a-f\\d]{2})*)";
const QUERY_FRAGMENT = "([&?]([\\w-.~!$&'()*+,;=:@/?]|%[a-f\\d]{2})*)?(#([\\w-.~!$&'()*+,;=:@/?]|%[a-f\\d]{2})*)?";
const URI1 = "(" + SCHEME + HIER_PART + QUERY_FRAGMENT + ")";

/*	URI REGULAR EXPRESSION
 */
var uriRegExp = new RegExp(URI1, "i");

/*	UNWANTED REGULAR EXPRESSION
 */
const unwantedRegExp = new RegExp("^((" + SCHEME + "?\\/*)|" + IPV4ADDRESS + ")$", "i");

function main()
{
	if (!metaRefresh() && !frameRedirection()) urlRedirection();
}

function metaRefresh()
{
	var metas = document.evaluate("./html/head/meta[translate(@http-equiv,'EFHRS','efhrs')='refresh']", document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	if (!metas || metas.snapshotLength <= 0) return false;
	window.addEventListener("load", function(){window.stop();}, false); // STOP REFRESH
	var content = metas.snapshotItem(0).getAttribute("content");
	var spacer = content.match(/^[0-9]+\s*;\s*(url=)?/i);
	if (!spacer) return false;
	insertRedirect(content.substring(spacer[0].length));
	return true;
}

function frameRedirection()
{
	var frames = document.evaluate(".//frame[@src]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (!frames || frames.snapshotLength != 1) return false;
	insertRedirect(frames.snapshotItem(0).src);
	return true;
}

function urlRedirection()
{
	var anchors = document.evaluate(".//a[contains(translate(substring(@href,2),'HPT','hpt'),'http')]", document.body, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (anchors && anchors.snapshotLength > 0) for (var i = 0; i < anchors.snapshotLength; i++) skipRedirect(anchors.snapshotItem(i));
}

function skipRedirect(anchor)
{
	var href = anchor.getAttribute("href");
	var tmp = href.toLowerCase();
	var index = tmp.lastIndexOf("http");
	var url = null;
	do
	{
		if (index <= 0) return;
		if (url = isURL(href, index)) break;
	} while (index = tmp.lastIndexOf("http", index-1));
	if (index > 0) anchor.setAttribute("href", url); // SKIP REDIRECT
}

function isURL(href, index)
{
	var tmp = href.substring(index).match(/^[^?#&]+/)[0];
	var prev = null;
	while (tmp.indexOf("%") > -1 && prev != tmp)
	{
		prev = tmp;
		tmp = unescape(tmp);
	}
	tmp = escape(tmp).replace(/%3A/, ":"); // GET RID OF SPACES
	var url = tmp.match(uriRegExp);
	if (url && !url[0].match(unwantedRegExp)) return unescape(url[0]);
	return null;
}

function insertRedirect(url)
{
	document.body.setAttribute("style", "margin-left: 0 !important; margin-right: 0 !important; margin-top: 0 !important; padding-left: 0 !important; padding-right: 0 !important; padding-top: 0 !important; text-align: left !important;");
	var div = document.createElement("div");
	div.setAttribute("style", "background-color: #f8f8ff !important; color: #333333 !important; display: block !important; font-family: sans-serif !important; font-size: 14px !important; padding: 5px !important;");
	var a = document.createElement("a");
	a.setAttribute("href", url);
	a.setAttribute("style", "background-color: #f8f8ff !important; color: #333333 !important; font-family: sans-serif !important; font-size: 14px !important; font-weight: normal !important;");
	a.appendChild(document.createTextNode(url));
	div.appendChild(document.createTextNode("Redirect to "));
	div.appendChild(a);
	document.body.insertBefore(div, document.body.firstChild);
}

main();
